Index: /stable/HeuristicLab 3.3.sln
===================================================================
--- /stable/HeuristicLab 3.3.sln	(revision 13292)
+++ /stable/HeuristicLab 3.3.sln	(revision 13293)
@@ -442,6 +442,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.GeneticProgramming.Views-3.3", "HeuristicLab.Problems.GeneticProgramming.Views\3.3\HeuristicLab.Problems.GeneticProgramming.Views-3.3.csproj", "{26349C8D-72A1-4BAE-95A3-14E96A3B4AE8}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Algorithms.OffspringSelectionEvolutionStrategy-3.3", "HeuristicLab.Algorithms.OffspringSelectionEvolutionStrategy\3.3\HeuristicLab.Algorithms.OffspringSelectionEvolutionStrategy-3.3.csproj", "{1D41EAE6-CC79-41D4-858C-589C4DB5E50D}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Algorithms.ALPS-3.3", "HeuristicLab.Algorithms.ALPS\3.3\HeuristicLab.Algorithms.ALPS-3.3.csproj", "{59F354CB-FE13-4253-AED2-AD86372BEC27}"
@@ -2149,16 +2147,4 @@
 		{26349C8D-72A1-4BAE-95A3-14E96A3B4AE8}.Release|x86.ActiveCfg = Release|x86
 		{26349C8D-72A1-4BAE-95A3-14E96A3B4AE8}.Release|x86.Build.0 = Release|x86
-		{1D41EAE6-CC79-41D4-858C-589C4DB5E50D}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{1D41EAE6-CC79-41D4-858C-589C4DB5E50D}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{1D41EAE6-CC79-41D4-858C-589C4DB5E50D}.Debug|x64.ActiveCfg = Debug|x64
-		{1D41EAE6-CC79-41D4-858C-589C4DB5E50D}.Debug|x64.Build.0 = Debug|x64
-		{1D41EAE6-CC79-41D4-858C-589C4DB5E50D}.Debug|x86.ActiveCfg = Debug|x86
-		{1D41EAE6-CC79-41D4-858C-589C4DB5E50D}.Debug|x86.Build.0 = Debug|x86
-		{1D41EAE6-CC79-41D4-858C-589C4DB5E50D}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{1D41EAE6-CC79-41D4-858C-589C4DB5E50D}.Release|Any CPU.Build.0 = Release|Any CPU
-		{1D41EAE6-CC79-41D4-858C-589C4DB5E50D}.Release|x64.ActiveCfg = Release|x64
-		{1D41EAE6-CC79-41D4-858C-589C4DB5E50D}.Release|x64.Build.0 = Release|x64
-		{1D41EAE6-CC79-41D4-858C-589C4DB5E50D}.Release|x86.ActiveCfg = Release|x86
-		{1D41EAE6-CC79-41D4-858C-589C4DB5E50D}.Release|x86.Build.0 = Release|x86
 		{59F354CB-FE13-4253-AED2-AD86372BEC27}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{59F354CB-FE13-4253-AED2-AD86372BEC27}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -2183,6 +2169,6 @@
 		{71CDE004-C50F-48DF-858E-AB0AAA3537BC} = {D1B1DE45-F9C7-4FBF-B73C-E759BC4223D5}
 		{5E516C4F-9935-437F-8B15-ECEF4451744E} = {D1B1DE45-F9C7-4FBF-B73C-E759BC4223D5}
+		{0C67A033-F6D9-4237-B3CA-C033A44706BE} = {D1B1DE45-F9C7-4FBF-B73C-E759BC4223D5}
 		{7FC70D74-1813-48B7-9CE5-0BD913457579} = {D1B1DE45-F9C7-4FBF-B73C-E759BC4223D5}
-		{0C67A033-F6D9-4237-B3CA-C033A44706BE} = {D1B1DE45-F9C7-4FBF-B73C-E759BC4223D5}
 	EndGlobalSection
 EndGlobal
Index: able/HeuristicLab.Optimization.Operators/3.3/ChildrenCopyCreator.cs
===================================================================
--- /stable/HeuristicLab.Optimization.Operators/3.3/ChildrenCopyCreator.cs	(revision 13292)
+++ 	(revision )
@@ -1,75 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Operators;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Optimization.Operators {
-  /// <summary>
-  /// Creates a copy of every sub-scope in the current scope and adds it as a child to the sub-scope.
-  /// </summary>
-  /// <remarks>
-  /// Creates a copy of every sub-scope in the current scope and adds it as a child to the sub-scope.
-  /// </remarks>
-  [Item("ChildrenCopyCreator", "Creates a copy of every sub-scope in the current scope and adds it as a child to the sub-scope.")]
-  [StorableClass]
-  public sealed class ChildrenCopyCreator : SingleSuccessorOperator {
-    private ScopeParameter CurrentScopeParameter {
-      get { return (ScopeParameter)Parameters["CurrentScope"]; }
-    }
-    public IScope CurrentScope {
-      get { return CurrentScopeParameter.ActualValue; }
-    }
-
-    [StorableConstructor]
-    private ChildrenCopyCreator(bool deserializing) : base(deserializing) { }
-    private ChildrenCopyCreator(ChildrenCopyCreator original, Cloner cloner) : base(original, cloner) { }
-    public ChildrenCopyCreator()
-      : base() {
-      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope whose sub-scopes should be copied."));
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new ChildrenCopyCreator(this, cloner);
-    }
-
-    public override IOperation Apply() {
-      int nChildren = CurrentScope.SubScopes.Count;
-
-      for (int i = 0; i < nChildren; i++) {
-        IScope child = CurrentScope.SubScopes[i];
-        if (child.SubScopes.Count > 0) throw new ArgumentException("The sub-scope that should be cloned has further sub-scopes.");
-
-        IScope childCopy = new Scope(i.ToString());
-        var cloner = new Cloner();
-        foreach (IVariable var in child.Variables)
-          childCopy.Variables.Add(cloner.Clone(var));
-
-        child.SubScopes.Add(childCopy);
-      }
-      return base.Apply();
-    }
-  }
-}
Index: /stable/HeuristicLab.Optimization.Operators/3.3/HeuristicLab.Optimization.Operators-3.3.csproj
===================================================================
--- /stable/HeuristicLab.Optimization.Operators/3.3/HeuristicLab.Optimization.Operators-3.3.csproj	(revision 13292)
+++ /stable/HeuristicLab.Optimization.Operators/3.3/HeuristicLab.Optimization.Operators-3.3.csproj	(revision 13293)
@@ -115,5 +115,4 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="ChildrenCopyCreator.cs" />
     <Compile Include="ExpressionCalculator.cs" />
     <Compile Include="NoSimilarityCalculator.cs" />
Index: able/HeuristicLab.Selection/3.3/EvolutionStrategyOffspringSelector.cs
===================================================================
--- /stable/HeuristicLab.Selection/3.3/EvolutionStrategyOffspringSelector.cs	(revision 13292)
+++ 	(revision )
@@ -1,262 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Runtime.InteropServices;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Operators;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Selection {
-  [Item("EvolutionStrategyOffspringSelector", "Selects among the offspring population those that are designated successful and discards the unsuccessful offspring, except for some lucky losers. It expects the parent scopes to be below the first sub-scope, and offspring scopes to be below the second sub-scope separated again in two sub-scopes, the first with the failed offspring and the second with successful offspring.")]
-  [StorableClass]
-  public class EvolutionStrategyOffspringSelector : SingleSuccessorOperator {
-
-    private class FitnessComparer : IComparer<IScope> {
-
-      #region IComparer<IScope> Member
-
-      private String qualityParameterName;
-      private bool maximization;
-
-      public FitnessComparer(String qualityParamName, bool maximization) {
-        this.qualityParameterName = qualityParamName;
-        this.maximization = maximization;
-      }
-
-      // less than zero if x is-better-than y 
-      // larger than zero if y is-better-than x
-      // zero if both are the same
-      public int Compare(IScope x, IScope y) {
-        IVariable quality1, quality2;
-
-        if (x.Variables.TryGetValue(qualityParameterName, out quality1)
-          && y.Variables.TryGetValue(qualityParameterName, out quality2)) {
-          DoubleValue left = quality1.Value as DoubleValue;
-          DoubleValue right = quality2.Value as DoubleValue;
-          var res = left.CompareTo(right);
-          if (maximization) return -res; // in the maximization case the largest value should preceed all others in the sort order
-          else return res;
-        } else
-          throw new ArgumentException("Quality variable " + qualityParameterName + " not found.");
-      }
-
-      #endregion
-    }
-
-    public ValueLookupParameter<DoubleValue> MaximumSelectionPressureParameter {
-      get { return (ValueLookupParameter<DoubleValue>)Parameters["MaximumSelectionPressure"]; }
-    }
-    public ValueLookupParameter<DoubleValue> SuccessRatioParameter {
-      get { return (ValueLookupParameter<DoubleValue>)Parameters["SuccessRatio"]; }
-    }
-    public LookupParameter<DoubleValue> SelectionPressureParameter {
-      get { return (ValueLookupParameter<DoubleValue>)Parameters["SelectionPressure"]; }
-    }
-    public LookupParameter<DoubleValue> CurrentSuccessRatioParameter {
-      get { return (LookupParameter<DoubleValue>)Parameters["CurrentSuccessRatio"]; }
-    }
-    public LookupParameter<ItemList<IScope>> OffspringPopulationParameter {
-      get { return (LookupParameter<ItemList<IScope>>)Parameters["OffspringPopulation"]; }
-    }
-    public LookupParameter<ItemList<IScope>> OffspringVirtualPopulationParameter {
-      get { return (LookupParameter<ItemList<IScope>>)Parameters["OffspringVirtualPopulation"]; }
-    }
-    public LookupParameter<IntValue> OffspringPopulationWinnersParameter {
-      get { return (LookupParameter<IntValue>)Parameters["OffspringPopulationWinners"]; }
-    }
-    public ScopeTreeLookupParameter<BoolValue> SuccessfulOffspringParameter {
-      get { return (ScopeTreeLookupParameter<BoolValue>)Parameters["SuccessfulOffspring"]; }
-    }
-    public OperatorParameter OffspringCreatorParameter {
-      get { return (OperatorParameter)Parameters["OffspringCreator"]; }
-    }
-    public LookupParameter<IntValue> EvaluatedSolutionsParameter {
-      get { return (LookupParameter<IntValue>)Parameters["EvaluatedSolutions"]; }
-    }
-    private LookupParameter<IntValue> MaximumEvaluatedSolutionsParameter {
-      get { return (LookupParameter<IntValue>)Parameters["MaximumEvaluatedSolutions"]; }
-    }
-    public ILookupParameter<DoubleValue> QualityParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
-    }
-    public ILookupParameter<BoolValue> MaximizationParameter {
-      get { return (ILookupParameter<BoolValue>)Parameters["Maximization"]; }
-    }
-
-    public IOperator OffspringCreator {
-      get { return OffspringCreatorParameter.Value; }
-      set { OffspringCreatorParameter.Value = value; }
-    }
-
-    [StorableConstructor]
-    protected EvolutionStrategyOffspringSelector(bool deserializing) : base(deserializing) { }
-    protected EvolutionStrategyOffspringSelector(EvolutionStrategyOffspringSelector original, Cloner cloner) : base(original, cloner) { }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new EvolutionStrategyOffspringSelector(this, cloner);
-    }
-    public EvolutionStrategyOffspringSelector()
-      : base() {
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("MaximumSelectionPressure", "The maximum selection pressure which prematurely terminates the offspring selection step."));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("SuccessRatio", "The ratio of successful offspring that has to be produced."));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("SelectionPressure", "The amount of selection pressure currently necessary to fulfill the success ratio."));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("CurrentSuccessRatio", "The current success ratio indicates how much of the successful offspring have already been generated."));
-      Parameters.Add(new LookupParameter<ItemList<IScope>>("OffspringPopulation", "Temporary store of the offspring population."));
-      Parameters.Add(new LookupParameter<ItemList<IScope>>("OffspringVirtualPopulation", "Temporary store of the offspring population."));
-      Parameters.Add(new LookupParameter<IntValue>("OffspringPopulationWinners", "Temporary store the number of successful offspring in the offspring population."));
-      Parameters.Add(new ScopeTreeLookupParameter<BoolValue>("SuccessfulOffspring", "True if the offspring was more successful than its parents.", 2));
-      Parameters.Add(new OperatorParameter("OffspringCreator", "The operator used to create new offspring."));
-      Parameters.Add(new LookupParameter<IntValue>("EvaluatedSolutions", "The number of solution evaluations."));
-      Parameters.Add(new LookupParameter<IntValue>("MaximumEvaluatedSolutions", "The maximum number of evaluated solutions (approximately)."));
-      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality of a child"));
-      Parameters.Add(new LookupParameter<BoolValue>("Maximization", "Flag that indicates if the problem is a maximization problem"));
-    }
-
-    public override IOperation Apply() {
-      double maxSelPress = MaximumSelectionPressureParameter.ActualValue.Value;
-      double successRatio = SuccessRatioParameter.ActualValue.Value;
-      IScope scope = ExecutionContext.Scope;
-      IScope parents = scope.SubScopes[0];
-      IScope offspring = scope.SubScopes[1];
-      int populationSize = parents.SubScopes.Count;
-
-      // retrieve actual selection pressure and success ratio
-      DoubleValue selectionPressure = SelectionPressureParameter.ActualValue;
-      if (selectionPressure == null) {
-        selectionPressure = new DoubleValue(0);
-        SelectionPressureParameter.ActualValue = selectionPressure;
-      }
-      DoubleValue currentSuccessRatio = CurrentSuccessRatioParameter.ActualValue;
-      if (currentSuccessRatio == null) {
-        currentSuccessRatio = new DoubleValue(0);
-        CurrentSuccessRatioParameter.ActualValue = currentSuccessRatio;
-      }
-
-      // retrieve next population
-      ItemList<IScope> population = OffspringPopulationParameter.ActualValue;
-      ItemList<IScope> virtual_population = OffspringVirtualPopulationParameter.ActualValue;
-
-      IntValue successfulOffspring;
-      if (population == null) {
-        population = new ItemList<IScope>();
-        OffspringPopulationParameter.ActualValue = population;
-        selectionPressure.Value = 0; // initialize selection pressure for this round
-        currentSuccessRatio.Value = 0; // initialize current success ratio for this round
-        successfulOffspring = new IntValue(0);
-        OffspringPopulationWinnersParameter.ActualValue = successfulOffspring;
-
-        virtual_population = new ItemList<IScope>();
-        OffspringVirtualPopulationParameter.ActualValue = virtual_population;
-      } else successfulOffspring = OffspringPopulationWinnersParameter.ActualValue;
-
-      int successfulOffspringAdded = 0;
-
-      // implement the ActualValue fetch here - otherwise the parent scope would also be included, given that there may be 1000 or more parents, this is quite unnecessary
-      string tname = SuccessfulOffspringParameter.TranslatedName;
-      double tmpSelPress = selectionPressure.Value;
-      double tmpSelPressInc = 1.0 / populationSize;
-      for (int i = 0; i < offspring.SubScopes.Count; i++) {
-        // fetch value
-        IVariable tmpVar;
-        if (!offspring.SubScopes[i].Variables.TryGetValue(tname, out tmpVar)) throw new InvalidOperationException(Name + ": Could not determine if an offspring was successful or not.");
-        BoolValue tmp = (tmpVar.Value as BoolValue);
-        if (tmp == null) throw new InvalidOperationException(Name + ": The variable that indicates whether an offspring is successful or not must contain a BoolValue.");
-
-        // add to population
-        if (tmp.Value) {
-          IScope currentOffspring = offspring.SubScopes[i];
-          offspring.SubScopes.RemoveAt(i);
-          i--; // next loop should continue with the subscope at index i which replaced currentOffspring
-          population.Add(currentOffspring);
-          successfulOffspringAdded++;
-        } else {
-          IScope currentOffspring = offspring.SubScopes[i];
-          offspring.SubScopes.RemoveAt(i);
-          i--;
-          virtual_population.Add(currentOffspring); // add to losers pool
-        }
-        tmpSelPress += tmpSelPressInc;
-
-        double tmpSuccessRatio = (successfulOffspring.Value + successfulOffspringAdded) / ((double)populationSize);
-        if (tmpSuccessRatio >= successRatio && (population.Count + virtual_population.Count) >= populationSize)
-          break;
-      }
-      successfulOffspring.Value += successfulOffspringAdded;
-
-      // calculate actual selection pressure and success ratio
-      selectionPressure.Value = tmpSelPress;
-      currentSuccessRatio.Value = successfulOffspring.Value / ((double)populationSize);
-
-      // check if enough children have been generated (or limit of selection pressure or evaluted solutions is reached)
-      if (((EvaluatedSolutionsParameter.ActualValue.Value < MaximumEvaluatedSolutionsParameter.ActualValue.Value)
-          && (selectionPressure.Value < maxSelPress)
-          && (currentSuccessRatio.Value < successRatio))
-        || ((population.Count + virtual_population.Count) < populationSize)) {
-        // more children required -> reduce left and start children generation again
-        scope.SubScopes.Remove(parents);
-        scope.SubScopes.Remove(offspring);
-        while (parents.SubScopes.Count > 0) {
-          IScope parent = parents.SubScopes[0];
-          parents.SubScopes.RemoveAt(0); // TODO: repeated call of RemoveAt(0) is inefficient?
-          scope.SubScopes.Add(parent); // order of subscopes is reversed
-        }
-
-        IOperator offspringCreator = OffspringCreatorParameter.ActualValue as IOperator;
-        if (offspringCreator == null) throw new InvalidOperationException(Name + ": More offspring are required, but no operator specified for creating them.");
-        return ExecutionContext.CreateOperation(offspringCreator); // this assumes that this operator will be called again indirectly or directly
-      } else {
-        // enough children generated
-        var fitnessComparer = new FitnessComparer(QualityParameter.TranslatedName, MaximizationParameter.ActualValue.Value);
-        population.Sort(fitnessComparer); // sort individuals by descending fitness
-
-        // keeps only the best successRatio * populationSize solutions in the population (the remaining ones are added to the virtual population)
-        int removed = 0;
-        for (int i = 0; i < population.Count; i++) {
-          double tmpSuccessRatio = i / (double)populationSize;
-          if (tmpSuccessRatio > successRatio) {
-            virtual_population.Add(population[i]);
-            removed++;
-          }
-        }
-        population.RemoveRange(population.Count - removed, removed);
-
-        //fill up population with best remaining children (successful or unsuccessful)
-        virtual_population.Sort(fitnessComparer);
-        int offspringNeeded = populationSize - population.Count;
-        for (int i = 0; i < offspringNeeded && i < virtual_population.Count; i++) {
-          population.Add(virtual_population[i]); // children are sorted by descending fitness
-        }
-
-        offspring.SubScopes.Clear();
-        offspring.SubScopes.AddRange(population);
-
-        scope.Variables.Remove(OffspringPopulationParameter.TranslatedName);
-        scope.Variables.Remove(OffspringVirtualPopulationParameter.TranslatedName);
-        scope.Variables.Remove(OffspringPopulationWinnersParameter.TranslatedName);
-        return base.Apply();
-      }
-    }
-  }
-}
Index: /stable/HeuristicLab.Selection/3.3/HeuristicLab.Selection-3.3.csproj
===================================================================
--- /stable/HeuristicLab.Selection/3.3/HeuristicLab.Selection-3.3.csproj	(revision 13292)
+++ /stable/HeuristicLab.Selection/3.3/HeuristicLab.Selection-3.3.csproj	(revision 13293)
@@ -119,5 +119,4 @@
     <Compile Include="ConditionalSelector.cs" />
     <Compile Include="CrowdedTournamentSelector.cs" />
-    <Compile Include="EvolutionStrategyOffspringSelector.cs" />
     <Compile Include="GeneralizedRankSelector.cs" />
     <Compile Include="LeftSelector.cs" />
Index: able/HeuristicLab.Tests/HeuristicLab-3.3/Samples/OSESGriewankSampleTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/Samples/OSESGriewankSampleTest.cs	(revision 13292)
+++ 	(revision )
@@ -1,99 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.IO;
-using HeuristicLab.Algorithms.EvolutionStrategy;
-using HeuristicLab.Algorithms.OffspringSelectionEvolutionStrategy;
-using HeuristicLab.Data;
-using HeuristicLab.Encodings.RealVectorEncoding;
-using HeuristicLab.Persistence.Default.Xml;
-using HeuristicLab.Problems.TestFunctions;
-using Microsoft.VisualStudio.TestTools.UnitTesting;
-
-namespace HeuristicLab.Tests {
-  [TestClass]
-  public class OSESGriewankSampleTest {
-    private const string SampleFileName = "OSES_Griewank";
-
-    [TestMethod]
-    [TestCategory("Samples.Create")]
-    [TestProperty("Time", "medium")]
-    public void CreateOSESGriewankSampleTest() {
-      var es = CreateOSESGriewankSample();
-      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
-      XmlGenerator.Serialize(es, path);
-    }
-
-    [TestMethod]
-    [TestCategory("Samples.Execute")]
-    [TestProperty("Time", "long")]
-    public void RunOSESGriewankSampleTest() {
-      var es = CreateOSESGriewankSample();
-      es.SetSeedRandomly.Value = false;
-      SamplesUtils.RunAlgorithm(es);
-      Assert.AreEqual(1.80366417E-07, SamplesUtils.GetDoubleResult(es, "BestQuality"), 1.0E-15);
-      Assert.AreEqual(4.84418627E-07, SamplesUtils.GetDoubleResult(es, "CurrentAverageQuality"), 1.0E-15);
-      Assert.AreEqual(9.20629802E-07, SamplesUtils.GetDoubleResult(es, "CurrentWorstQuality"), 1.0E-15);
-      Assert.AreEqual(39750, SamplesUtils.GetIntResult(es, "EvaluatedSolutions"));
-    }
-
-    private OffspringSelectionEvolutionStrategy CreateOSESGriewankSample() {
-      OffspringSelectionEvolutionStrategy es = new OffspringSelectionEvolutionStrategy();
-
-      #region Problem Configuration
-
-      SingleObjectiveTestFunctionProblem problem = new SingleObjectiveTestFunctionProblem();
-
-      problem.ProblemSize.Value = 10;
-      problem.EvaluatorParameter.Value = new GriewankEvaluator();
-      problem.SolutionCreatorParameter.Value = new UniformRandomRealVectorCreator();
-      problem.Maximization.Value = false;
-      problem.Bounds = new DoubleMatrix(new double[,] { { -600, 600 } });
-      problem.BestKnownQuality.Value = 0;
-      problem.BestKnownSolutionParameter.Value = new RealVector(10);
-      problem.Name = "Single Objective Test Function";
-      problem.Description = "Test function with real valued inputs and a single objective.";
-
-      #endregion
-
-      #region Algorithm Configuration
-
-      es.Name = "Offspring Selection Evolution Strategy - Griewank";
-      es.Description = "An evolution strategy with offspring selection which solves the 10-dimensional Griewank test function";
-      es.Problem = problem;
-      SamplesUtils.ConfigureOffspringSelectionEvolutionStrategyParameters<AverageCrossover, NormalAllPositionsManipulator,
-        StdDevStrategyVectorCreator, StdDevStrategyVectorCrossover, StdDevStrategyVectorManipulator>(es, 50, 1.0, 0.5, 100, 2, 100, false);
-
-      StdDevStrategyVectorCreator strategyCreator = (StdDevStrategyVectorCreator)es.StrategyParameterCreator;
-      strategyCreator.BoundsParameter.Value = new DoubleMatrix(new double[,] { { 1, 20 } });
-
-      StdDevStrategyVectorManipulator strategyManipulator =
-        (StdDevStrategyVectorManipulator)es.StrategyParameterManipulator;
-      strategyManipulator.BoundsParameter.Value = new DoubleMatrix(new double[,] { { 1E-12, 30 } });
-      strategyManipulator.GeneralLearningRateParameter.Value = new DoubleValue(0.22360679774997896);
-      strategyManipulator.LearningRateParameter.Value = new DoubleValue(0.39763536438352531);
-
-      #endregion
-
-      return es;
-    }
-  }
-}
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/Samples/SamplesUtils.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/Samples/SamplesUtils.cs	(revision 13292)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/Samples/SamplesUtils.cs	(revision 13293)
@@ -5,5 +5,4 @@
 using HeuristicLab.Algorithms.EvolutionStrategy;
 using HeuristicLab.Algorithms.GeneticAlgorithm;
-using HeuristicLab.Algorithms.OffspringSelectionEvolutionStrategy;
 using HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm;
 using HeuristicLab.Data;
@@ -72,43 +71,4 @@
     }
 
-    public static void ConfigureOffspringSelectionEvolutionStrategyParameters<R, M, SC, SR, SM>(OffspringSelectionEvolutionStrategy es, int popSize,
-      double successRatio, double comparisonFactor, double maxSelPres, int parentsPerChild, int maxGens, bool plusSelection)
-      where R : ICrossover
-      where M : IManipulator
-      where SC : IStrategyParameterCreator
-      where SR : IStrategyParameterCrossover
-      where SM : IStrategyParameterManipulator {
-      es.PopulationSize.Value = popSize;
-      es.ComparisonFactor.Value = comparisonFactor;
-      es.SuccessRatio.Value = successRatio;
-      es.MaximumSelectionPressure.Value = maxSelPres;
-      es.ParentsPerChild.Value = parentsPerChild;
-      es.SelectedParents.Value = popSize * parentsPerChild;
-      es.MaximumGenerations.Value = maxGens;
-      es.PlusSelection.Value = false;
-
-      es.Seed.Value = 0;
-      es.SetSeedRandomly.Value = true;
-
-      es.Recombinator = es.RecombinatorParameter.ValidValues
-        .OfType<R>()
-        .Single();
-
-      es.Mutator = es.MutatorParameter.ValidValues
-        .OfType<M>()
-        .Single();
-
-      es.StrategyParameterCreator = es.StrategyParameterCreatorParameter.ValidValues
-        .OfType<SC>()
-        .Single();
-      es.StrategyParameterCrossover = es.StrategyParameterCrossoverParameter.ValidValues
-        .OfType<SR>()
-        .Single();
-      es.StrategyParameterManipulator = es.StrategyParameterManipulatorParameter.ValidValues
-        .OfType<SM>()
-        .Single();
-      es.Engine = new ParallelEngine.ParallelEngine();
-    }
-
     public static void ConfigureGeneticAlgorithmParameters<S, C, M>(GeneticAlgorithm ga, int popSize, int elites, int maxGens, double mutationRate, int tournGroupSize = 0)
       where S : ISelector
@@ -234,5 +194,5 @@
 
       ga.MaximumGenerations = maxGens;
-
+      
       ga.Engine = new ParallelEngine.ParallelEngine();
     }
Index: /stable/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 13292)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 13293)
@@ -131,8 +131,4 @@
     <Reference Include="HeuristicLab.Algorithms.LocalSearch-3.3">
       <HintPath>..\bin\HeuristicLab.Algorithms.LocalSearch-3.3.dll</HintPath>
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.Algorithms.OffspringSelectionEvolutionStrategy-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <HintPath>..\bin\HeuristicLab.Algorithms.OffspringSelectionEvolutionStrategy-3.3.dll</HintPath>
       <Private>False</Private>
     </Reference>
@@ -440,5 +436,4 @@
     <Compile Include="HeuristicLab-3.3\PluginLoader.cs" />
     <Compile Include="HeuristicLab-3.3\Samples\AlpsSampleTest.cs" />
-    <Compile Include="HeuristicLab-3.3\Samples\OSESGriewankSampleTest.cs" />
     <Compile Include="HeuristicLab-3.3\Samples\GAGroupingProblemSampleTest.cs" />
     <Compile Include="HeuristicLab-3.3\Samples\VnsOpSampleTest.cs" />