Index: branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Advanced/IStatusDisplay.cs
===================================================================
--- branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Advanced/IStatusDisplay.cs	(revision 13334)
+++ 	(revision )
@@ -1,34 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-
-namespace HeuristicLab.PluginInfrastructure.Advanced {
-  internal interface IStatusView {
-    void ShowProgressIndicator(double percentProgress);
-    void ShowProgressIndicator();
-    void HideProgressIndicator();
-    void ShowMessage(string message);
-    void RemoveMessage(string message);
-    void LockUI();
-    void UnlockUI();
-    void ShowError(string shortMessage, string description);
-  }
-}
Index: branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Advanced/InstallationManagerControl.cs
===================================================================
--- branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Advanced/InstallationManagerControl.cs	(revision 13334)
+++ branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Advanced/InstallationManagerControl.cs	(revision 13335)
@@ -23,9 +23,4 @@
 namespace HeuristicLab.PluginInfrastructure.Advanced {
   internal partial class InstallationManagerControl : UserControl {
-    private IStatusView statusView;
-    public IStatusView StatusView {
-      get { return statusView; }
-      set { statusView = value; }
-    }
 
     public InstallationManagerControl()
Index: branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Advanced/InstallationManagerForm.Designer.cs
===================================================================
--- branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Advanced/InstallationManagerForm.Designer.cs	(revision 13334)
+++ branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Advanced/InstallationManagerForm.Designer.cs	(revision 13335)
@@ -119,5 +119,4 @@
       this.localPluginsView.PluginManager = null;
       this.localPluginsView.Size = new System.Drawing.Size(578, 354);
-      this.localPluginsView.StatusView = null;
       this.localPluginsView.TabIndex = 0;
       // 
Index: branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Advanced/InstallationManagerForm.cs
===================================================================
--- branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Advanced/InstallationManagerForm.cs	(revision 13334)
+++ branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Advanced/InstallationManagerForm.cs	(revision 13335)
@@ -20,14 +20,9 @@
 #endregion
 using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.IO;
-using System.Linq;
-using System.Text;
 using System.Windows.Forms;
 using HeuristicLab.PluginInfrastructure.Manager;
 
 namespace HeuristicLab.PluginInfrastructure.Advanced {
-  internal partial class InstallationManagerForm : Form, IStatusView {
+  internal partial class InstallationManagerForm : Form {
     private string pluginDir;
 
@@ -37,35 +32,9 @@
       Text = "HeuristicLab Plugin Manager " + AssemblyHelpers.GetFileVersion(GetType().Assembly);
 
-      pluginManager.PluginLoaded += pluginManager_PluginLoaded;
-      pluginManager.PluginUnloaded += pluginManager_PluginUnloaded;
-      pluginManager.Initializing += pluginManager_Initializing;
-      pluginManager.Initialized += pluginManager_Initialized;
-
       pluginDir = Application.StartupPath;
 
-      localPluginsView.StatusView = this;
       localPluginsView.PluginManager = pluginManager;
       // localPluginsView.InstallationManager = installationManager;
     }
-
-
-    #region plugin manager event handlers
-    private void pluginManager_Initialized(object sender, PluginInfrastructureEventArgs e) {
-      SetStatusStrip("Initialized PluginInfrastructure");
-    }
-
-    private void pluginManager_Initializing(object sender, PluginInfrastructureEventArgs e) {
-      SetStatusStrip("Initializing PluginInfrastructure");
-    }
-
-    private void pluginManager_PluginUnloaded(object sender, PluginInfrastructureEventArgs e) {
-      SetStatusStrip("Unloaded " + e.Entity);
-    }
-
-    private void pluginManager_PluginLoaded(object sender, PluginInfrastructureEventArgs e) {
-      SetStatusStrip("Loaded " + e.Entity);
-    }
-    #endregion
-
 
     #region button events
@@ -74,64 +43,4 @@
     }
     #endregion
-
-    #region helper methods
-    private void SetStatusStrip(string msg) {
-      if (InvokeRequired) Invoke((Action<string>)SetStatusStrip, msg);
-      else {
-        toolStripStatusLabel.Text = msg;
-        logTextBox.Text += DateTime.Now + ": " + msg + Environment.NewLine;
-      }
-    }
-
-    #endregion
-
-
-    #region IStatusView Members
-
-    public void ShowProgressIndicator(double percentProgress) {
-      if (percentProgress < 0.0 || percentProgress > 1.0) throw new ArgumentException("percentProgress");
-      toolStripProgressBar.Visible = true;
-      toolStripProgressBar.Style = ProgressBarStyle.Continuous;
-      int range = toolStripProgressBar.Maximum - toolStripProgressBar.Minimum;
-      toolStripProgressBar.Value = (int)(percentProgress * range + toolStripProgressBar.Minimum);
-    }
-
-    public void ShowProgressIndicator() {
-      toolStripProgressBar.Visible = true;
-      toolStripProgressBar.Style = ProgressBarStyle.Marquee;
-    }
-
-    public void HideProgressIndicator() {
-      toolStripProgressBar.Visible = false;
-    }
-
-    public void ShowMessage(string message) {
-      if (string.IsNullOrEmpty(toolStripStatusLabel.Text))
-        toolStripStatusLabel.Text = message;
-      else
-        toolStripStatusLabel.Text += "; " + message;
-    }
-
-    public void RemoveMessage(string message) {
-      if (toolStripStatusLabel.Text.IndexOf("; " + message) > 0) {
-        toolStripStatusLabel.Text = toolStripStatusLabel.Text.Replace("; " + message, "");
-      }
-      toolStripStatusLabel.Text = toolStripStatusLabel.Text.Replace(message, "");
-      toolStripStatusLabel.Text = toolStripStatusLabel.Text.TrimStart(' ', ';');
-    }
-    public void LockUI() {
-      Cursor = Cursors.AppStarting;
-      tabControl.Enabled = false;
-    }
-    public void UnlockUI() {
-      tabControl.Enabled = true;
-      Cursor = Cursors.Default;
-    }
-    public void ShowError(string shortMessage, string description) {
-      logTextBox.Text += DateTime.Now + ": " + shortMessage + Environment.NewLine + description + Environment.NewLine;
-      MessageBox.Show(description, shortMessage);
-    }
-    #endregion
-
   }
 }
Index: branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Advanced/Util.cs
===================================================================
--- branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Advanced/Util.cs	(revision 13334)
+++ branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Advanced/Util.cs	(revision 13335)
@@ -39,37 +39,4 @@
         ResizeColumn(columnHeader);
     }
-
-    internal static IEnumerable<IPluginDescription> GetAllDependents(IPluginDescription plugin, IEnumerable<IPluginDescription> availablePlugins) {
-      return from p in availablePlugins
-             let matchingEntries = from dep in GetAllDependencies(p)
-                                   where dep.Name == plugin.Name
-                                   where dep.Version == plugin.Version
-                                   select dep
-             where matchingEntries.Any()
-             select p as IPluginDescription;
-    }
-
-    internal static IEnumerable<IPluginDescription> GetAllDependencies(IPluginDescription plugin) {
-      HashSet<IPluginDescription> yieldedPlugins = new HashSet<IPluginDescription>();
-      foreach (var dep in plugin.Dependencies) {
-        foreach (var recDep in GetAllDependencies(dep)) {
-          if (!yieldedPlugins.Contains(recDep)) {
-            yieldedPlugins.Add(recDep);
-            yield return recDep;
-          }
-        }
-        if (!yieldedPlugins.Contains(dep)) {
-          yieldedPlugins.Add(dep);
-          yield return dep;
-        }
-      }
-    }
-
-    // compares for two plugins with same major and minor version if plugin1 is newer than plugin2
-    internal static bool IsNewerThan(IPluginDescription plugin1, IPluginDescription plugin2) {
-      // newer: build version is higher, or if build version is the same revision is higher
-      return plugin1.Version.Build > plugin2.Version.Build ||
-        (plugin1.Version.Build == plugin2.Version.Build && plugin1.Version.Revision > plugin2.Version.Revision);
-    }
   }
 }
Index: branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/HeuristicLab.PluginInfrastructure-3.3.csproj
===================================================================
--- branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/HeuristicLab.PluginInfrastructure-3.3.csproj	(revision 13334)
+++ branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/HeuristicLab.PluginInfrastructure-3.3.csproj	(revision 13335)
@@ -139,7 +139,4 @@
       <DependentUpon>InstalledPluginsView.cs</DependentUpon>
     </Compile>
-    <Compile Include="Advanced\IStatusDisplay.cs">
-      <SubType>Code</SubType>
-    </Compile>
     <Compile Include="Advanced\LicenseView.cs">
       <SubType>Form</SubType>
@@ -210,5 +207,4 @@
     <Compile Include="Manager\ApplicationDescription.cs" />
     <Compile Include="Manager\PluginFile.cs" />
-    <Compile Include="Manager\PluginInfrastructureCancelEventArgs.cs" />
     <Compile Include="Manager\PluginDescription.cs" />
     <Compile Include="Manager\PluginInfrastructureEventArgs.cs" />
@@ -286,7 +282,5 @@
     </BootstrapperPackage>
   </ItemGroup>
-  <ItemGroup>
-    <Folder Include="Advanced\DeploymentService\" />
-  </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Manager/PluginInfrastructureCancelEventArgs.cs
===================================================================
--- branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Manager/PluginInfrastructureCancelEventArgs.cs	(revision 13334)
+++ 	(revision )
@@ -1,36 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-
-namespace HeuristicLab.PluginInfrastructure.Manager {
-  // to be replaced by GenericEventArgs
-  [Serializable]
-  internal sealed class PluginInfrastructureCancelEventArgs : CancelEventArgs {
-    internal IEnumerable<IPluginDescription> Plugins { get; private set; }
-    internal PluginInfrastructureCancelEventArgs(IEnumerable<IPluginDescription> plugins)
-      : base() {
-      this.Plugins = plugins;
-    }
-  }
-}
Index: branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Sandboxing/SandboxManager.cs
===================================================================
--- branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Sandboxing/SandboxManager.cs	(revision 13334)
+++ branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Sandboxing/SandboxManager.cs	(revision 13335)
@@ -27,4 +27,5 @@
 
 namespace HeuristicLab.PluginInfrastructure.Sandboxing {
+  // used by Hive Slave
   public static class SandboxManager {
     /// <summary>